#Использовать ".."
#Использовать "."
#Использовать 1testrunner
#Использовать asserts

&Тест
Процедура ВалидацияОграничениеЗаполненоРаботает() Экспорт

	// Дано
	Валидатор = Новый Валидатор;
	ТестовыйОбъект = Новый ТестовыйОбъект;
	ТестовыйОбъект.Поле1 = "Значение1";

	// Когда
	РезультатВалидации = Валидатор.Валидировать(ТестовыйОбъект);

	// Тогда
	Ожидаем.Что(РезультатВалидации).ИмеетДлину(1);

	Нарушение = РезультатВалидации[0];
	Ожидаем.Что(Нарушение.Объект()).Равно(ТестовыйОбъект);
	Ожидаем.Что(Нарушение.ИмяСвойства()).Равно("Поле2");
	Ожидаем.Что(Нарушение.Сообщение()).Равно("Значение не заполнено");
	Ожидаем.Что(Нарушение.Код()).Равно("filled");

КонецПроцедуры


&Тест
Процедура МожноПереопределитьСообщениеВалидации() Экспорт

	// Дано
	Валидатор = Новый Валидатор;
	ТестовыйОбъект = Новый ТестовыйОбъект;
	ТестовыйОбъект.Поле2 = "Значение2";

	// Когда
	РезультатВалидации = Валидатор.Валидировать(ТестовыйОбъект);

	// Тогда
	Ожидаем.Что(РезультатВалидации).ИмеетДлину(1);

	Нарушение = РезультатВалидации[0];
	Ожидаем.Что(Нарушение.Объект()).Равно(ТестовыйОбъект);
	Ожидаем.Что(Нарушение.ИмяСвойства()).Равно("Поле1");
	Ожидаем.Что(Нарушение.Сообщение()).Равно("Произвольное сообщение");
	Ожидаем.Что(Нарушение.Код()).Равно("filled");

КонецПроцедуры

&Тест
Процедура ВалидацияОграниченияМинимумРаботает() Экспорт

	// Дано
	Валидатор = Новый Валидатор;
	ТестовыйОбъект = Новый ТестовыйОбъект;
	ТестовыйОбъект.Поле1 = "Значение1";
	ТестовыйОбъект.Поле2 = "Значение1";
	ТестовыйОбъект.Поле3 = -15;

	// Когда
	РезультатВалидации = Валидатор.Валидировать(ТестовыйОбъект);

	// Тогда
	Ожидаем.Что(РезультатВалидации).ИмеетДлину(1);

	Нарушение = РезультатВалидации[0];
	Ожидаем.Что(Нарушение.Объект()).Равно(ТестовыйОбъект);
	Ожидаем.Что(Нарушение.ИмяСвойства()).Равно("Поле3");
	Ожидаем.Что(Нарушение.Сообщение()).Равно("Значение меньше минимального <-10>");
	Ожидаем.Что(Нарушение.Код()).Равно("min");

КонецПроцедуры


&Тест
Процедура ВалидацияОграниченияМаксимумРаботает() Экспорт

	// Дано
	Валидатор = Новый Валидатор;
	ТестовыйОбъект = Новый ТестовыйОбъект;
	ТестовыйОбъект.Поле1 = "Значение1";
	ТестовыйОбъект.Поле2 = "Значение1";
	ТестовыйОбъект.Поле3 = 15;

	// Когда
	РезультатВалидации = Валидатор.Валидировать(ТестовыйОбъект);

	// Тогда
	Ожидаем.Что(РезультатВалидации).ИмеетДлину(1);

	Нарушение = РезультатВалидации[0];
	Ожидаем.Что(Нарушение.Объект()).Равно(ТестовыйОбъект);
	Ожидаем.Что(Нарушение.ИмяСвойства()).Равно("Поле3");
	Ожидаем.Что(Нарушение.Сообщение()).Равно("Значение больше максимального <10>");
	Ожидаем.Что(Нарушение.Код()).Равно("max");

КонецПроцедуры

&Тест
Процедура ВалидацияОграничениеВалидноРаботает() Экспорт

	// Дано
	Валидатор = Новый Валидатор;

	ВложенныйОбъект = Новый ТестовыйОбъект;

	ТестовыйОбъект = Новый ТестовыйОбъект;
	ТестовыйОбъект.Поле1 = "Значение1";
	ТестовыйОбъект.ВложенныйОбъект = ВложенныйОбъект;

	// Когда
	РезультатВалидации = Валидатор.Валидировать(ТестовыйОбъект);

	// Тогда
	Ожидаем.Что(РезультатВалидации).ИмеетДлину(2);

	Нарушение = РезультатВалидации[0];
	Ожидаем.Что(Нарушение.Объект()).Равно(ТестовыйОбъект);
	Ожидаем.Что(Нарушение.ИмяСвойства()).Равно("Поле2");
	Ожидаем.Что(Нарушение.Сообщение()).Равно("Значение не заполнено");
	Ожидаем.Что(Нарушение.Код()).Равно("filled");

	Нарушение = РезультатВалидации[1];
	Ожидаем.Что(Нарушение.Объект()).Равно(ТестовыйОбъект);
	Ожидаем.Что(Нарушение.ИмяСвойства()).Равно("ВложенныйОбъект");
	Ожидаем.Что(Нарушение.Сообщение()).Равно("Значение не валидно");
	Ожидаем.Что(Нарушение.Код()).Равно("valid");

КонецПроцедуры

// ВалидацияОграничениеЗаполненоРаботает();
